parse("sv_name Bomberman Server Lua:Mratakan")
parse("sv_maxplayers 21")
parse("mp_wpndmg Knife 0")
parse("mp_wpndmg_z1 Knife 0")
parse("mp_wpndmg usp 0")
parse("mp_wpndmg glock 0")
parse("mp_wpndmg \"Chainsaw\" 10")
parse("mp_wpndmg \"Snowball\" 2000")
parse("mp_wpndmg \"Air Strike\" 2000")
parse("mp_wpndmg \"Laser Mine\" 1000")
parse("mp_wpndmg \"HE\" 500")
parse("mp_wpndmg \"Mine\" 750")
parse("mp_wpndmg \"Molotov Cocktail\" 2000")
parse("mp_wpndmg \"Gut Bomb\" 2000")
parse("mp_deathdrop 0")
parse("mp_dropgrenades 0")
parse("mp_startmoney 0")
parse("mp_killbuildingmoney 0")
parse("mp_dmspawnmoney 0")
parse("mp_curtailedexplosions 1")
parse("mp_freezetime 1")
parse("sv_gamemode 1")
parse("mp_respawndelay 255")
parse("mp_roundtime 3")
parse("mp_killbuildings 3")
parse("sv_rcon bomberman")
if hye and hye.autobot then
	hye.autobot = 0
end

bm = {}
bm.restart = 0
bm.objects = {}
bm.bombtime = 3
bm.triptime = 3
bm.maxbombs = {}
bm.activebombs = {}
bm.invincible = {}
bm.bombidtoplayerid = {}
bm.lastbombtime = {}
bm.score = {}
bm.maxroundtime = 120
bm.roundtime = bm.maxroundtime
bm.spawnpoint = {}
bm.spawnpoint[1] = {}
bm.spawnpoint[1].x = 17
bm.spawnpoint[1].y = 17
bm.spawnpoint[2] = {}
bm.spawnpoint[2].x = 33
bm.spawnpoint[2].y = 31
bm.spawnpoint[3] = {}
bm.spawnpoint[3].x = 17
bm.spawnpoint[3].y = 31
bm.spawnpoint[4] = {}
bm.spawnpoint[4].x = 33
bm.spawnpoint[4].y = 17
bm.spawnpoint[5] = {}
bm.spawnpoint[5].x = 13
bm.spawnpoint[5].y = 24
bm.spawnpoint[6] = {}
bm.spawnpoint[6].x = 37
bm.spawnpoint[6].y = 24
bm.spawnpoint[7] = {}
bm.spawnpoint[7].x = 25
bm.spawnpoint[7].y = 13
bm.spawnpoint[8] = {}
bm.spawnpoint[8].x = 25
bm.spawnpoint[8].y = 35

-- returns a random number from zero to limit
function rand(limit)
        if (not limit) then limit = 1 end
        local rnum = math.random(limit + 1) - 1
        return rnum
end

function hook_startround_bm()
  bm.restart = 0
  parse("sv_sound fun/prepare.wav")
  
  -- Clear bomb hash
  bm.bombidtoplayerid = {}
  bm.objects = {}
  
  local randstart = rand(7)
  
  for p = 1, 8, 1 do
    local randspawn = randstart + p
    if randspawn > 8 then randspawn = randspawn - 8 end
    if player(p, "exists") and player(p, "health") > 0 then
      local x = (bm.spawnpoint[randspawn].x * 32) + 16
      local y = (bm.spawnpoint[randspawn].y * 32) + 16
      parse("spawnplayer "..p.." "..x.." "..y)
      parse("strip "..p)
      parse("equip "..p.." 87")
      bm.maxbombs[p] = 1
      bm.activebombs[p] = 0
      bm.roundtime = bm.maxroundtime
      if (not bm.score[p]) then bm.score[p] = 0 end
      bm.invincible[p] = nil
    end
  end
  
  for x = 17, 33, 1 do 
    for y = 17, 31, 1 do
      -- do not block spawnpoints!
      if (x == 17 and y == 17) then
      elseif (x == 18 and y == 17) then
      elseif (x == 17 and y == 18) then
      elseif (x == 17 and y == 19) then
      elseif (x == 33 and y == 17) then
      elseif (x == 32 and y == 17) then
      elseif (x == 31 and y == 17) then
      elseif (x == 33 and y == 18) then
      elseif (x == 33 and y == 31) then
      elseif (x == 32 and y == 31) then
      elseif (x == 33 and y == 30) then
      elseif (x == 33 and y == 29) then
      elseif (x == 17 and y == 31) then
      elseif (x == 18 and y == 31) then
      elseif (x == 17 and y == 30) then
      elseif (x == 19 and y == 31) then
      -- do not spawn over walls
      elseif (x%2 == 0 and y%2 == 0) then
      elseif (rand(100) < 75) then
        local wall = 3 + rand(1)
        parse("spawnobject "..wall.." "..x.." "..y)
        if (rand(100) < 22) then
          if (rand(100) < 50) then
            parse("spawnitem 87 "..x.." "..y)
          elseif (rand(100) < 10) then
            if (rand(100) < 25) then
              parse("spawnitem 77 "..x.." "..y)
            elseif (rand(100) < 33) then
              parse("spawnitem 85 "..x.." "..y)
            elseif (rand(100) < 50) then
              parse("spawnitem 70 "..x.." "..y)
            else
              parse("spawnitem 51 "..x.." "..y)
            end
          elseif (rand(100) < 33) then
            parse("spawnitem 71 "..x.." "..y)
          elseif (rand(100) < 50) then
            parse("spawnitem 86 "..x.." "..y)
          else
            parse("spawnitem 52 "..x.." "..y)
          end
        end
      end
    end
  end
  parse("sv_msg \"255255255Lua By Mratakan Rady!@C\"")
end

function weapondrop()
  for x = 17, 33, 1 do 
    for y = 17, 31, 1 do
      if (x%2 == 0 and y%2 == 0) then
      elseif (rand(100) < 75) then
        local wall = 3 + rand(1)
        if (rand(100) < 20) then
          if (rand(100) < 50) then
            parse("spawnitem 87 "..x.." "..y)
          elseif (rand(100) < 10) then
            if (rand(100) < 25) then
              parse("spawnitem 77 "..x.." "..y)
            elseif (rand(100) < 33) then
              parse("spawnitem 85 "..x.." "..y)
            elseif (rand(100) < 50) then
              parse("spawnitem 70 "..x.." "..y)
            else
              parse("spawnitem 51 "..x.." "..y)
            end
          elseif (rand(100) < 33) then
            parse("spawnitem 71 "..x.." "..y)
          elseif (rand(100) < 50) then
            parse("spawnitem 86 "..x.." "..y)
          else
            parse("spawnitem 52 "..x.." "..y)
          end
        end
      end
    end
  end
end

function hook_build_bm(p,t,x,y,m,objectid)
  -- laser mine = 21
  -- mine = 20
  bm.lastbombtime[p] = os.time()
  if (t == 20) then
--    bm.objects[objectid] = os.time() + bm.bombtime
  elseif (t == 21) then
    bm.objects[objectid] = os.time() + bm.triptime
  end
  if (t == 21) then
    bm.activebombs[p] = bm.activebombs[p] + 1 
    bm.bombidtoplayerid[objectid] = p
    if (bm.activebombs[p] >= bm.maxbombs[p]) then
      bm.activebombs[p] = bm.maxbombs[p]
      parse("strip "..p.." 87")
    end
  end
end

function hook_always_bm()
  if bm.restart ~= 0 then
    return 0
  end
  for k, v in pairs(bm.objects) do
    if (v ~= nil) then
      local explodetime = tonumber(v)
      if explodetime <= os.time() then
        local p = bm.bombidtoplayerid[k]
        if (p ~= nil and player(p, "exists") and player(p, "health") > 0) then
          bm.activebombs[p] = bm.activebombs[p] - 1
          if (bm.activebombs[p] < 0) then
            bm.activebombs[p] = 0
          end
        end
        bm.objects[k] = nil
        bm.bombidtoplayerid[k] = nil
        parse("killobject "..k)
      end
    end
  end
  
end

function hook_second_bm()
  if bm.restart ~= 0 then
    return 0
  end
  
  parse("mp_wpndmg \"Laser Mine\" 1000")

  local playersexist = 0
  local playersalive = 0
  local lastplayeralive = 0
  for p = 1, 8, 1 do
    if player(p, "exists") then
      if player(p, "team") ~= 0 then
        playersexist = playersexist + 1
      end
      if bm.score[p] ~= nil then
        parse("setscore "..p.." "..bm.score[p])
      end
      if player(p, "bot") then parse("strip "..p.." 50") end
      if player(p, "health") > 0 then
        playersalive = playersalive + 1
        lastplayeralive = p
        if bm.invincible[p] ~= nil and bm.invincible[p] > 0 then
          bm.invincible[p] = bm.invincible[p] - 1
        elseif bm.invincible[p] ~= nil and bm.invincible[p] <= 0 then
          parse("sv_msg 200200200"..player(p, "name").." IS NO LONGER INVINCIBLE!@C")
          parse("sv_sound player/dominate.wav")
          bm.invincible[p] = nil
        end
        if (bm.activebombs[p] ~= nil and bm.maxbombs[p] ~= nil) then
          if (bm.activebombs[p] < bm.maxbombs[p]) then
             parse("equip "..p.." 87")
          end
        end
        if (bm.lastbombtime[p] ~= nil and bm.lastbombtime[p] + (bm.triptime * 2) < os.time()) then
          bm.activebombs[p] = 0
          parse("equip "..p.." 87")
        end
      end
    end
  end

  if playersalive == 1 and playersexist > 1 then
    winner(lastplayeralive)
    return 0
  elseif playersalive == 0 and playersexist > 0 then
    drawgame()
    return 0
  end

  if bm.roundtime > 0 then
    local minutes = 3
    local seconds = 0
    if bm.roundtime >= 180 then
      minutes = 3
      seconds = bm.roundtime - 180
    elseif bm.roundtime >= 120 then
      minutes = 2
      seconds = bm.roundtime - 120
    elseif bm.roundtime >= 60 then
      minutes = 1
      seconds = bm.roundtime - 60
    else
      minutes = 0
      seconds = bm.roundtime
    end
    
    if seconds < 10 then
      seconds = "0" .. seconds
    end
    
    local timeleft = minutes .. ":" .. seconds 
    
    if (bm.roundtime > 30) then
      parse("hudtxt 0 \"255255000"..timeleft.."\" 320 422 1")
    else
      parse("hudtxt 0 \"255000000"..timeleft.."\" 320 422 1")
    end
    bm.roundtime = bm.roundtime - 1
    if (bm.roundtime == 30) then
      parse("sv_msg \"255255000HURRY UP!!!@C\"")
    elseif (bm.roundtime == 0) then
      parse("sv_msg \"255000000SUDDEN DEATH!@C\"")
      weapondrop()
    end
  else
    for p = 1, 8, 1 do
      if player(p, "exists") and player(p, "health") > 0 then
        parse("sethealth "..p.." "..player(p, "health") - 3)
      end
    end 
    parse("hudtxt 0 \"255255000SUDDEN DEATH\" 320 422 1")
  end
  
end

function hook_leave_bm(p)
  bm.maxbombs[p] = 1
  bm.activebombs[p] = 0
  bm.score[p] = nil
  bm.invincible[p] = nil
end

function hook_walkover_bm(p, itemid, typ)
  if (typ == 87) then
    bm.maxbombs[p] = bm.maxbombs[p] + 1
    parse("removeitem "..itemid)
    parse("sv_sound items/pickup.wav")
    parse("sv_msg2 "..p.." 255255255You picked up an extra mine!")
    if (bm.activebombs[p] < bm.maxbombs[p]) then
      parse("equip "..p.." 87")
    end
    return 1
  elseif (typ == 71) then
    parse("removeitem "..itemid)
    parse("sv_sound items/pickup.wav")
    parse("sv_sound player/spawn.wav")
    parse("speedmod "..p.." 10")
    parse("sv_msg2 "..p.." 255255255You gained the speed powerup!")
    return 1
  elseif (typ == 70) then
    parse("removeitem "..itemid)
    parse("sv_sound items/pickup.wav")
    parse("sv_sound fun/godlike.wav")
    bm.invincible[p] = 10
    parse("sv_msg2 "..p.." 255255255You are invincible for 10 seconds!")
    parse("sv_msg 255255255"..player(p, "name").." PICKED UP INVINCIBILITY!@C")
    return 1
  end
end

function hook_die_bm(p,k,w,x,y)
  parse("strip "..p)
  bm.maxbombs[p] = 1
  bm.activebombs[p] = 0
  bm.invincible[p] = nil
  
  local tilex = player(p, "tilex")
  local tiley = player(p, "tiley")
  
  --Enemy drops a powerup
  if (rand(100) < 33) then
    parse("spawnitem 71 "..tilex.." "..tiley)
  elseif (rand(100) < 50) then
    parse("spawnitem 87 "..tilex.." "..tiley)
  else
    parse("spawnitem 86 "..tilex.." "..tiley)
  end
end

function hook_hit_bm(p,source,weapon,hpdmg,apdmg)
  if (bm.invincible[p] ~= nil and bm.invincible[p] > 0) then
    return 1
  end
end

function winner(p)
  bm.restart = 1
  if (bm.score[p] ~= nil) then
    bm.score[p] = bm.score[p] + 1
  end 
  if (player(p, "exists")) then
    parse("sv_msg \"255255255WINNER: "..player(p, "name").."@C\"")
    parse("sv_sound radio/enemydown.ogg")
  end
  parse("sv_restart 5")
end

function drawgame()
  bm.restart = 1
  parse("sv_msg \"255255255DRAW GAME@C\"")
  parse("sv_sound radio/rounddraw.ogg")
  parse("sv_restart 5")
end

function hook_join_bm(p)
  bm.score[p] = 0
end

addhook("startround", "hook_startround_bm", 10)
addhook("build", "hook_build_bm", 10)
addhook("always", "hook_always_bm", 10)
addhook("die", "hook_die_bm", 10)
addhook("leave", "hook_leave_bm", 10)
addhook("walkover", "hook_walkover_bm", 10)
addhook("second", "hook_second_bm", 10)
addhook("hit", "hook_hit_bm", 10)
addhook("join", "hook_join_bm", 10)
